<?xml version="1.0" encoding="iso-8859-1" standalone="yes" ?>
<!-- $Id: form-bibtex.xsl,v 1.3 2002/10/31 16:04:02 jerome Exp $ -->

<xsl:stylesheet version="1.0"
  xml:space="default"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:bib="http://exmo.inrialpes.fr/papers"
  xmlns:date="http://www.jclark.com/xt/java/java.util.Date"
  xmlns:java="http://xml.apache.org/xslt/java">

<xsl:import href="common.xsl" />

<xsl:output method="text" media-type="text/plain" encoding="iso-8859-1"/>

<xsl:strip-space elements="*"/>

<!-- toplevel -->

<xsl:template match="/">
% File generated by bibML2BibTeX
<xsl:if test="function-available('date:to-string') and function-available('date:new')">% on <xsl:value-of select="date:to-string(date:new())"/></xsl:if>
<xsl:if test="function-available('java:toString') and function-available('java:java.util.Date.new')">% on <xsl:value-of select="java:toString(java:java.util.Date.new())"/></xsl:if>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="bibliography">
% <xsl:value-of select="@name"/> bibliography (<xsl:value-of select="@date"/>)
	<xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="reference">
@<xsl:call-template name="typedef"/>{<xsl:value-of select="@index"/>,<xsl:apply-templates/>
	<xsl:if test="@language">
	LANGUAGE = "<xsl:value-of select='@language'/>",</xsl:if>
	CREATEDBY = "BibML2BibTeX"}
</xsl:template>

<xsl:template name="typedef">
  <xsl:choose>
    <xsl:when test="@type='inproceedings'">inproceedings</xsl:when>
    <xsl:when test="@type='inbook'">inbook</xsl:when>
    <xsl:when test="@type='incollection'">incollection</xsl:when>
    <xsl:when test="@type='article'">article</xsl:when>
    <xsl:when test="@type='techreport' or @type='internalreport' or @type='deliverable'">techreport</xsl:when>
    <xsl:when test="@type='proceedings' or @type='serialproceedings'">proceedings</xsl:when>
    <xsl:when test="@type='book' or @type='collection'">book</xsl:when>
    <xsl:when test="@type='phd'">phdthesis</xsl:when>
    <xsl:when test="@type='mastersthesis'">mastersthesis</xsl:when>
    <xsl:when test="@type='manual'">manual</xsl:when>
    <xsl:when test="@type='booklet'">booklet</xsl:when>
    <xsl:when test="@type='bulletin'">article</xsl:when>
    <xsl:when test="@type='lecturenotes'">misc</xsl:when>
    <xsl:when test="@type='motionpictures'">misc</xsl:when>
    <xsl:otherwise>misc</xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="authors"> <!-- // -->
	AUTHOR = "<xsl:apply-templates select='p[1]'/>
	<xsl:for-each select='p[position()>1]'> and <xsl:apply-templates select='.'/>
	</xsl:for-each>",</xsl:template>

<xsl:template match="authors"> <!-- // -->
	AUTHOR = "<xsl:apply-templates select='p[1]'/>
	<xsl:for-each select='p[position()>1]'> and <xsl:apply-templates select='.'/>
	</xsl:for-each>",</xsl:template>

<xsl:template match="editors">
	EDITOR = "<xsl:apply-templates select='p[1]'/>
	<xsl:for-each select='p[position()>1]'> and <xsl:apply-templates select='.'/>
	</xsl:for-each>",</xsl:template>

<xsl:template match="title">
	TITLE = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="publisher">
	PUBLISHER = "<xsl:value-of select='@name'/>",<xsl:if test="location">
	ADDRESS = "<xsl:apply-templates select='location'/>",</xsl:if></xsl:template>

<xsl:template match="type">
	TYPE = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<!-- // ISSUE and ORGANISATION ARE NOT ALLWAYS DISPLAYED SPONTANEOUSLY -->
	<!-- xsl:if test='@issue'>
	ISSUE = <xsl:value-of select='@issue'/>,</xsl:if>
        BOOKTITLE = "<xsl:value-of select='@type'/><xsl:choose><xsl:when test="../@language='fr'"><xsl:text> sur </xsl:text></xsl:when><xsl:otherwise><xsl:text> on </xsl:text></xsl:otherwise></xsl:choose><xsl:value-of select='@name'/>, <xsl:apply-templates select='location'/>",<xsl:if test="@sponsor">
	ORGANISATION = "<xsl:value-of select='@sponsor'/>",</xsl:if></xsl:template !-->

<xsl:template match="conference">
	BOOKTITLE = "<xsl:choose>
        <xsl:when test="../@language='fr'"><xsl:text>Actes </xsl:text></xsl:when>
			<xsl:otherwise><xsl:text>Proc. </xsl:text></xsl:otherwise>
			</xsl:choose>
                        <xsl:if test="@issue">
                          <xsl:value-of select="@issue"/>
                          <xsl:call-template name="coderank">
                       			<xsl:with-param name="num" select="@issue"/>
                                        <xsl:with-param name="language" select="../@language"/>
                                      </xsl:call-template>
			</xsl:if>
                        <xsl:if test="@sponsor and ../@language='en'">
				<xsl:value-of select="@sponsor"/>
				<xsl:text> </xsl:text>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="@type"><xsl:value-of select="@type"/></xsl:when>
				<xsl:otherwise><xsl:text>conference</xsl:text></xsl:otherwise>
			</xsl:choose>
			<xsl:text> </xsl:text>
                        <xsl:if test="@sponsor and ../@language='fr'">
				<xsl:value-of select="@sponsor"/>
			</xsl:if>
			<xsl:if test="@name">
                          <xsl:choose>
                            <xsl:when test="../@language='fr'"><xsl:text> sur </xsl:text></xsl:when>
			    <xsl:otherwise><xsl:text> on </xsl:text></xsl:otherwise>
                              </xsl:choose>
				<xsl:value-of select="@name"/>
			</xsl:if>
			<xsl:if test="@short">
				<xsl:text> (</xsl:text>
				<xsl:value-of select="@short"/>
				<xsl:text>)</xsl:text>
			</xsl:if>
			<xsl:text>, </xsl:text>
			<xsl:if test="location">
				<xsl:apply-templates select="location"/>
                              </xsl:if>",</xsl:template>

<xsl:template match="in">
	BOOKTITLE = "<xsl:value-of select='reference/title'/>",<xsl:if test="reference/authors">
	EDITOR = "<xsl:apply-templates select='reference/authors/p[1]'/><xsl:for-each select='reference/authors/p[position()>1]'> and <xsl:apply-templates select='.'/>
	</xsl:for-each>",</xsl:if><xsl:if test="reference/editors">
	EDITOR = "<xsl:apply-templates select='reference/editors/p[1]'/><xsl:for-each select='reference/editors/p[position()>1]'> and <xsl:apply-templates select='.'/>
	</xsl:for-each>",</xsl:if>
	<xsl:apply-templates select='reference/publisher'/></xsl:template>

<xsl:template match="trad|trans|red|rev"/>

<xsl:template match="organization|institution">
	INSTITUTION = "<xsl:value-of select='@name'/>",<xsl:if test="location">
	ADDRESS = "<xsl:apply-templates select="location"/>",</xsl:if></xsl:template>

<xsl:template match="school">
	SCHOOL = "<xsl:value-of select='@name'/>",<xsl:if test="location">
	ADDRESS = "<xsl:apply-templates select="location"/>",</xsl:if></xsl:template>

<xsl:template match="chapter">
	CHAPTER = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="howpublished">
	HOWPUBLISHED = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="journal">
	JOURNAL = "<xsl:value-of select='@name'/>",<xsl:if test="publisher"><xsl:apply-templates select="publisher"/>
	</xsl:if></xsl:template>

<xsl:template match="edition">
	EDITION = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="volume">
	VOLUME = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="number">
	NUMBER = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="pages">
	PAGES = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<!--xsl:template match="length">
  <xsl:if test="@unit='p'">
    PAGES = "<xsl:value-of select='normalize-space()'/>",</xsl:if></xsl:template-->

<xsl:template match="date">
	<xsl:if test="month">
        MONTH = "<xsl:call-template name="codemonth">
                        	<xsl:with-param name="month" select="@month"/>
                                <xsl:with-param name="language" select="../@language"/>
                              </xsl:call-template>",</xsl:if>
	YEAR = "<xsl:value-of select='@year'/>",</xsl:template>

<xsl:template match="address">
	ADDRESS = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="links"><xsl:apply-templates select="url[1]"/></xsl:template>

<xsl:template match="url">
	URL = "<xsl:value-of select='@href'/>",</xsl:template>

<xsl:template match="series">
	SERIES = "<xsl:value-of select='@name'/>",</xsl:template>

<xsl:template match="note">
	NOTE = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="comments">
	ANNOTE = "<xsl:value-of select='normalize-space()'/>",</xsl:template>

<xsl:template match="p">{<xsl:value-of select="@last"/>}, {<xsl:value-of select="@title"/> <xsl:value-of select="@first"/>}</xsl:template>

<xsl:template match="location">
	<xsl:if test="@place"><xsl:value-of select="@place"/><xsl:text>, </xsl:text></xsl:if>
	<xsl:if test="@city"><xsl:value-of select="@city"/></xsl:if>
	<xsl:if test="@country"><xsl:text> (</xsl:text>
		<xsl:if test="@state"><xsl:value-of select="@state"/><xsl:text> </xsl:text></xsl:if>
		<xsl:value-of select="@country"/>)</xsl:if></xsl:template>

<!-- this could be put back now -->
<xsl:template match="areas|softwares|contracts|keywords|abstract|comments"/>

<xsl:template match="text()"/>

<xsl:template match="li"><xsl:value-of select="normalize-space()"/></xsl:template>

</xsl:stylesheet>
