/**
 * $Id: Port.java,v 1.1 2002/11/06 14:08:21 serge Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph list of ports/channels
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.graph ;
import java.io.Serializable;

public class Port implements Serializable{

    
    public static int OUTPUT = 0;
    public static int INPUT  = 1;
    

    Channel chan = null;
    Transformation tOwner = null;
    Call cOwner = null;
    int number = 0;
    String name = null;

    int type;
    
    public Port(){
    }
    
    /** Port creator for transformations */
    public Port( String n, Transformation t, int i){
	name = n;
	number = i;
	tOwner = t;
    }
        
   
    /** Port creator for transformations */
    public Port( String n, Transformation t, int i, int type){
	name = n;
	number = i;
	tOwner = t;
	this.type = type;
    }
    
    

    /** Port creator for calls */
    public Port( String n, Call c, int i){
	name = n;
	number = i;
	cOwner = c;
    }

    public Port( String n, Call c, int i,int  type){
	    name = n;
	    number = i;
	    cOwner = c;
	    this.type = type;
    }
    

    public void setChannel( Channel c ){
	chan = c;
	if(c!= null)
	    name = c.getName();
	else
	    name = "";
    }
    
    public Channel getChannel(){
	return chan;
    }
    
    public void setName(String newName){
	name = newName;
    }

    public String getName(){
	return name;
    }
    
    public int getType(){
	return type;
    }

    public boolean TransformationPortP(){
	return ( tOwner != null ) ;
    }
    
    public boolean CallPortP(){
	return ( cOwner != null );
    }
    
    public Transformation getTransformation(){
	return tOwner;
    }
    
    public Call getCall(){
	return cOwner;
    }
    
} //end class

