/**
 * $Id: Serialize.java,v 1.1 2002/11/06 14:08:21 serge Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001-2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph serializer node interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

/** CAUTION, This will have to change the parameter cannot always be a file */

package fr.fluxmedia.transmorpher.graph ;

import fr.fluxmedia.transmorpher.utils.Writer;
import fr.fluxmedia.transmorpher.engine.TProcessFactory;
import fr.fluxmedia.transmorpher.engine.TProcessComposite;
import fr.fluxmedia.transmorpher.engine.TProcess;

import java.io.IOException;

public class Serialize extends CallImpl {

    public Serialize(){
	this(null,null);
    }

    public Serialize(String n,String t){
	this(n,t,(String)null);
    }

    public Serialize(String n,String t, String file){
	this(n,t,null,0,file);
    }
    
    public Serialize(String n, String t, Process p){
	this(n,t,p,0);
    }
    
  public Serialize(String n,String t, String file, Process p){
      this(n,t,p,0,file);
  }
    
    public Serialize (String n, String t, Process p, int in){
	this(n,t,p,in,null);
    }
    
    /** For compatibility with pre-1.0 Transmorpher */
    public Serialize (String n, String t, Process p, int in, String file){
	super(n, t, p, in, 0);
	/** This is for legacy code */
	if (file != null ) parameters.setParameter("file",file);
    }

      /** A serialize cannot be nullified */
  public void retroNull( PortList out, PortList in) {
      visited = true;
      in.getPort(0).getChannel().setVisited();

      update(null);
  }

    public void setFile(String uri){
	if(uri!=null)
	     parameters.setParameter("file",uri);
    }



  
  public void generateXML (){
    System.out.print("      <serialize id=\""+id+"\" type=\""+getType()+"\"");
    System.out.print(" in=\"");
    inPorts.generateXML();
    if ( parameters.isEmpty() ){
      System.out.println("\"/>");
    } else {
      System.out.println("\">");
      parameters.generateXMLCalls();
      System.out.println("      </serialize>");
    }
  }

 public  final void createProcess(TProcessComposite currentProcess, TProcessFactory iProcessFactory){
    String[] vPortIn = inPorts().toStringList();
    //String f = (String)getParameters().getParameter("file") ;
    //System.out.println("[ExecutionStrucutre] "+getAttributes().getParameter("file"));   
    TProcess vCurrent = (TProcess)iProcessFactory.newSerializer(vPortIn,
					     getAttributes().getStringParameter("type"),
                                             getParameters(),
                                             getAttributes());
    currentProcess.addProcess(vCurrent);

    update(vCurrent);
    
  } //end proc

  public void generateJavaCode(Writer file) throws IOException {
      file.writeln();
      file.writeln(4,"//------------------ Generation of Serializer "+getId()+" -------------------");
      generatePorts(file);
      generateParameters(file);
      file.writeln(4,"tmCurrentProcess = tmProcessFactory.newSerializer(portIn,\""+getType()+"\",tmParameters,tmAttributes);");
      file.writeln(4,"tmCurrentProcess.setName(\""+getId()+"\");");
      file.writeln();
      file.writeln(4,"tmCurrentCompositeProcess.addProcess(tmCurrentProcess);");
  } //end proc

}
