/**
 * $Id: XSLTTemplate.java,v 1.1 2002/11/06 14:08:21 serge Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001-2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph XSLT Template node
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.graph.Rules ;

import fr.fluxmedia.transmorpher.utils.Writer;

public class XSLTTemplate implements Rule {

  public String match = null;
  public String mode = null;
  public String content = null;

  public XSLTTemplate(String m, String md){
    super();
    match = m;
    mode = md;
  }

  public String getMode(){
    return mode;
  }

  public String getMatch(){
    return match;
  }

  public String getContent(){
    return content;
  }

  public void setContent(String c){
    content = c;
  }

  /** Prints the XML expression of the rule */
  public void generateXML(){
    System.out.print("    <xsl:template match=\""+match+"\"");
    if ( mode != null ) System.out.print(" mode=\""+mode+"\">");
    else System.out.print(">");
    // JE: Certainly not the corect way to do it
    System.out.println(content);
    System.out.print("    </xsl:template>");
  }

  public void generateXSLTCode(Writer file){
    // JE: set the current output to RW
    generateXML();
  }

  /** Prints the XSLT code inside a ModTag template */
    public void generateInsideXSLTCode(Writer file){
	// JE: Certainly not the corect way to do it
	System.out.println(content);
    }

}
