/**
 * $Id: CompleteTest.java,v 1.2 2002/09/30 16:12:35 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package fr.fluxmedia.transmorpher.Graph.Rules;

import junit.framework.TestCase;
// JUnitDoclet begin import
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the the authors.
*/

public class CompleteTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
    Rule r;
    ModTag modtag;
  // JUnitDoclet end class
  
  public CompleteTest(String name) {
    // JUnitDoclet begin method AddAttTest()
    super(name);
    // JUnitDoclet end method AddAttTest()
  }

  public void setUp() throws Exception {
    // JUnitDoclet begin method setUp()
    super.setUp();
    modtag = new ModTag( "tag", "path" );
    // JUnitDoclet end method setUp()
  }
  
  public void tearDown() throws Exception {
    // JUnitDoclet begin method tearDown()
    //modtag = null;
    // JUnitDoclet end method tearDown()
  }

    public void testExtends(){
	r = new Extends( "rulesetName" );
	assertTrue( ((Extends)r).ruleset.equals("rulesetName") );
    }


    public void testNamespace(){
	r = new Namespace( "abb", "uri" );
	assertTrue( ((Namespace)r).name.equals("abb") );
	assertTrue( ((Namespace)r).uri.equals("uri") );
     }


    public void testRemTag(){
	r = new RemTag( "tag" );
	assertTrue( ((RemTag)r).match.equals("tag") );
	assertTrue( ((RemTag)r).context == null );
	r = new RemTag( "tag", "path" );
	assertTrue( ((RemTag)r).match.equals("tag") );
	assertTrue( ((RemTag)r).context != null );
	assertTrue( ((RemTag)r).context.equals("path") );
    }


    public void testAddTag(){
	r = new AddTag( "tag" );
	assertTrue( ((AddTag)r).match.equals("tag") );
	assertTrue( ((AddTag)r).context == null );
	r = new AddTag( "tag", "path" );
	assertTrue( ((AddTag)r).match.equals("tag") );
	assertTrue( ((AddTag)r).context != null );
	assertTrue( ((AddTag)r).context.equals("path") );
    }

    public void testMapTag(){
	r = new MapTag( "tag", "subs" );
	assertTrue( ((MapTag)r).match.equals("tag") );
	assertTrue( ((MapTag)r).target.equals("subs") );
	assertTrue( ((MapTag)r).context == null );
	r = new MapTag( "tag", "subs", "path" );
	assertTrue( ((MapTag)r).match.equals("tag") );
	assertTrue( ((MapTag)r).target.equals("subs") );
	assertTrue( ((MapTag)r).context != null );
	assertTrue( ((MapTag)r).context.equals("path") );
    }

    public void testFlatten(){
	r = new Flatten( "tag" );
	assertTrue( ((Flatten)r).match.equals("tag") );
    }

    public void testModTag(){
	modtag = new ModTag( "tag" );
	assertTrue( modtag.match.equals("tag") );
	assertTrue( modtag.context == null );
	assertTrue( modtag.rules != null );
	modtag = new ModTag( "tag", "path" );
	assertTrue( modtag.match.equals("tag") );
	assertTrue( modtag.context != null );
	assertTrue( modtag.context.equals("path") );
	assertTrue( modtag.rules != null );
    }

    public void testAddAtt(){
	r = new AddAtt( "att", "val" );
	assertTrue( ((AddAtt)r).match.equals("att") );
	assertTrue( ((AddAtt)r).value.equals("val") );
	modtag.addRule( r );
	assertTrue( modtag.rules.contains((Object)r) );
    }

    public void testMapAtt(){
	r = new MapAtt( "att", "subs" );
	assertTrue( ((MapAtt)r).match.equals("att") );
	assertTrue( ((MapAtt)r).target.equals("subs") );
	assertTrue( ((MapAtt)r).context == null );
	r = new MapAtt( "att", "subs", "path" );
	assertTrue( ((MapAtt)r).match.equals("att") );
	assertTrue( ((MapAtt)r).target.equals("subs") );
	assertTrue( ((MapAtt)r).context != null );
	assertTrue( ((MapAtt)r).context.equals("path") );
	modtag.addRule( r );
	assertTrue( modtag.rules.contains((Object)r) );
    }


    public void testDefAtt(){
	r = new DefAtt( "att", "val" );
	assertTrue( ((DefAtt)r).match.equals("att") );
	assertTrue( ((DefAtt)r).value.equals("val") );
	assertTrue( ((DefAtt)r).context == null );
	r = new DefAtt( "att", "val", "path" );
	assertTrue( ((DefAtt)r).match.equals("att") );
	assertTrue( ((DefAtt)r).value.equals("val") );
	assertTrue( ((DefAtt)r).context != null );
	assertTrue( ((DefAtt)r).context.equals("path") );
	modtag.addRule( r );
	assertTrue( modtag.rules.contains((Object)r) );
    }

    public void testRemAtt(){
	r = new RemAtt( "att" );
	assertTrue( ((RemAtt)r).match.equals("att") );
	assertTrue( ((RemAtt)r).context == null );
	r = new RemAtt( "att", "path" );
	assertTrue( ((RemAtt)r).match.equals("att") );
	assertTrue( ((RemAtt)r).context != null );
	assertTrue( ((RemAtt)r).context.equals("path") );
	modtag.addRule( r );
	assertTrue( modtag.rules.contains((Object)r) );
    }

    public void testRESubst(){
	r = new RESubst( "path", "src", "tgt" );
	assertTrue( ((RESubst)r).match.equals("path") );
	assertTrue( ((RESubst)r).source.equals("src") );
	assertTrue( ((RESubst)r).target.equals("tgt") );
	assertTrue( ((RESubst)r).context == null );
	assertTrue( ((RESubst)r).apply.equals("all") );
	r = new RESubst( "path", "path", "src", "tgt", "once" );
	assertTrue( ((RESubst)r).match.equals("path") );
	assertTrue( ((RESubst)r).source.equals("src") );
	assertTrue( ((RESubst)r).target.equals("tgt") );
	assertTrue( ((RESubst)r).context != null );
	assertTrue( ((RESubst)r).context.equals("path") );
	assertTrue( ((RESubst)r).apply != null );
	assertTrue( ((RESubst)r).apply.equals("once") );
	modtag.addRule( r );
	assertTrue( modtag.rules.contains((Object)r) );
    }

    public void testXSLTTemplate(){
	r = new XSLTTemplate( "path", "mode" );
	assertTrue( ((XSLTTemplate)r).match.equals("path") );
	assertTrue( ((XSLTTemplate)r).getMatch().equals("path") );
	assertTrue( ((XSLTTemplate)r).mode.equals("mode") );
	assertTrue( ((XSLTTemplate)r).getMode().equals("mode") );
	assertTrue( ((XSLTTemplate)r).content == null );
	((XSLTTemplate)r).setContent( "<some>content</some>" );
	assertTrue( ((XSLTTemplate)r).getContent() != null );
	assertTrue( ((XSLTTemplate)r).getContent().equals("<some>content</some>") );
	
    }

    public void testFullModify(){
	modtag.addRule( new AddAtt( "att", "val" ) );
	modtag.addRule( new MapAtt( "att", "subs", "path" ) );
	r = new RemAtt( "att", "path" ) ;
	modtag.addRule( r );
	modtag.addRule( new RemAtt( "att", "path" ) );
	modtag.addRule( new RESubst( "path", "path", "src", "tgt", "once" ) );
	modtag.addRule( new DefAtt( "att", "val", "path" ) );
	assertEquals( 6, modtag.rules.size() );
	assertTrue( modtag.rules.contains((Object)r) );
	// We are not here for testing this list stuff OK
    }

    public void testSelect(){
	r = new Select( "path" );
	assertTrue( ((Select)r).match.equals("path") );
    }

}
