package fr.fluxmedia.transmorpher.TProcessFactory;

import junit.framework.TestCase;
// JUnitDoclet begin import
import fr.fluxmedia.transmorpher.TProcessFactory.ContentHandlerInfo;
import org.xml.sax.helpers.LocatorImpl;
import org.xml.sax.Locator;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.AttributesImpl ;
import org.xml.sax.helpers.DefaultHandler ;
import org.xml.sax.SAXException;


// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the the authors.
*/


public class ContentHandlerInfoTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  fr.fluxmedia.transmorpher.TProcessFactory.ContentHandlerInfo contenthandlerinfo = null;
  // JUnitDoclet end class
  
  public ContentHandlerInfoTest(String name) {
    // JUnitDoclet begin method ContentHandlerInfoTest()
    super(name);
    // JUnitDoclet end method ContentHandlerInfoTest()
  }
  
  public void setUp() throws Exception {
    // JUnitDoclet begin method setUp()
    super.setUp();
    contenthandlerinfo = new fr.fluxmedia.transmorpher.TProcessFactory.ContentHandlerInfo(0);
    
		
		// JUnitDoclet end method setUp()
  }
  
  public void tearDown() throws Exception {
    // JUnitDoclet begin method tearDown()
    contenthandlerinfo = null;
    super.tearDown();
    // JUnitDoclet end method tearDown()
  }
  
  public void testGetStringParameter() throws Exception {
    // JUnitDoclet begin method testGetStringParameter()
		ContentHandlerInfo test=new ContentHandlerInfo(2,"test");
		assertEquals(test.getCommand(),2);
		assertEquals(test.getStringParameter(0),"test");
		
		test=new ContentHandlerInfo(1,"test0","test1","test2");
		assertEquals(test.getCommand(),1);
		for (int i=0;i<3;i++)
			assertEquals(test.getStringParameter(i),"test"+i);
		
		test=null;
    // JUnitDoclet end method testGetStringParameter()
  }
  
  public void testGetIntParameter() throws Exception {
    // JUnitDoclet begin method testGetIntParameter()
		char[] ch={'t','e'};
		ContentHandlerInfo test=new ContentHandlerInfo(2,ch,0,2);
		assertEquals(test.getIntParameter(0),0);
		assertEquals(test.getIntParameter(1),2);
		
		ch=null;
		test=null;
    // JUnitDoclet end method testGetIntParameter()
  }
  
  public void testGetLocatorParameter() throws Exception {
    // JUnitDoclet begin method testGetLocatorParameter()
		Locator loc=new LocatorImpl();
		ContentHandlerInfo test=new ContentHandlerInfo(2,loc);
		
		assertEquals(test.getLocatorParameter(),loc);
    loc=null;
		test=null;
		// JUnitDoclet end method testGetLocatorParameter()
  }
  
  public void testGetAttributes() throws Exception {
    // JUnitDoclet begin method testGetAttributes()
		Attributes att=new AttributesImpl();
		ContentHandlerInfo test=new ContentHandlerInfo(2,"t","t","t",att);
		//test creates a new Attributes object with att.
		//assertEquals(test.getAttributes(),att);
		
    // JUnitDoclet end method testGetAttributes()
  }
  
  public void testGetCommand() throws Exception {
    // JUnitDoclet begin method testGetCommand()
		assertEquals(contenthandlerinfo.getCommand(),0);
		
		ContentHandlerInfo test=new ContentHandlerInfo(2);
		assertEquals(test.getCommand(),2);
		
		test=null;
    // JUnitDoclet end method testGetCommand()
  }
  
  public void testGetCharParameter() throws Exception {
    // JUnitDoclet begin method testGetCharParameter()
		char[] ch={'t','e','s','t'};
		char[] chTest;
		ContentHandlerInfo test=new ContentHandlerInfo(2,ch,0,2);
		
		chTest=test.getCharParameter();
		
		for (int i=0;i<chTest.length;i++)
			assertEquals(ch[i],chTest[i]);
		
		ch=null;
		chTest=null;
		test=null;
    // JUnitDoclet end method testGetCharParameter()
  }
  
  public void testToString() throws Exception {
    // JUnitDoclet begin method testToString()
		ContentHandlerInfo test = new ContentHandlerInfo(0);
		assertEquals(test.toString(),"START_ELEMENT");
		
		test = new ContentHandlerInfo(1);
		assertEquals(test.toString(),"END_ELEMENT");
		
		test = new ContentHandlerInfo(2);
		assertEquals(test.toString(),"START_DOCUMENT");
		
		test = new ContentHandlerInfo(3);
		assertEquals(test.toString(),"END_DOCUMENT");
		
		test = new ContentHandlerInfo(4);
		assertEquals(test.toString(),"SET_DOCUMENT_LOCATOR");
		
		test = new ContentHandlerInfo(5);
		assertEquals(test.toString(),"SKIPPED_ENTITY");
		
		test = new ContentHandlerInfo(6);
		assertEquals(test.toString(),"IGNORABLE_WHITESPACE");
		
		test = new ContentHandlerInfo(7);
		assertEquals(test.toString(),"PROCESSING_INSTRUCTION");
		
		test = new ContentHandlerInfo(8);
		assertEquals(test.toString(),"CHARACTERS");
		
		test = new ContentHandlerInfo(9);
		assertEquals(test.toString(),"START_PREFIX_MAPPING");
		
		test = new ContentHandlerInfo(10);
		assertEquals(test.toString(),"END_PREFIX_MAPPING");
		
		test=null;
    // JUnitDoclet end method testToString()
  }
  
  public void testSendEvent() throws Exception {
    // JUnitDoclet begin method testSendEvent()
		UnitTestHandler defHandler = new UnitTestHandler();

		Attributes att=new AttributesImpl();
		ContentHandlerInfo test=new ContentHandlerInfo(0,"","","test",att);
		test.sendEvent(defHandler);
		
		test=new ContentHandlerInfo(1,"","","test");
		test.sendEvent(defHandler);
		
		test=new ContentHandlerInfo(2);
		test.sendEvent(defHandler);
		
		test=new ContentHandlerInfo(3);
		test.sendEvent(defHandler);
		
		Locator loc=new LocatorImpl();
		test=new ContentHandlerInfo(4,loc);
		
		test=new ContentHandlerInfo(7,"target","data");
		test.sendEvent(defHandler);

		char[] ch={'t','e','s','t'};
		test=new ContentHandlerInfo(8,ch,0,4);
		test.sendEvent(defHandler);
		
		test=new ContentHandlerInfo(9,"aa","bb");
		test.sendEvent(defHandler);
		
		test=new ContentHandlerInfo(10,"aa");
		test.sendEvent(defHandler);

    // JUnitDoclet end method testSendEvent()
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testVault()
    // JUnitDoclet end method testVault()
  }
  class UnitTestHandler extends DefaultHandler{
				
		boolean isDocument=false;
		Object test="";
		
		public void startDocument() throws SAXException {
			isDocument=true;
		}
		
		public void endDocument() throws SAXException {
			assertTrue(isDocument);
			isDocument=false;
		}
		
		public void startElement(String ns, String localName, String name, Attributes atts) throws SAXException {
			assertEquals(ns,"");
			assertEquals(localName,"");
			assertTrue(atts!=null);
			assertEquals(name,"test");
		}
		
		public final void setDocumentLocator(Locator locator) {
			assertTrue(locator!=null);
			test=locator;
    }
		
		 public final void processingInstruction(java.lang.String target, java.lang.String data) throws SAXException {
			 assertEquals(target,"target");
			 assertEquals(data,"data");
			 
			 test=target;
    }
		public void endElement(String ns, String localName, String name) throws SAXException {
			assertEquals(ns,"");
			assertEquals(localName,"");
			assertEquals(name,"test");
		}
		
		public final void characters(char[] ch, int start, int length) throws SAXException{
			assertEquals(ch[start],'t');
			assertEquals(length,4);
			test=ch;
		}
		
		public void startPrefixMapping(String ns,String uri) throws SAXException{
			assertEquals(ns,"aa");
			assertEquals(uri,"bb");
		}
		
		public void endPrefixMapping(String ns) throws SAXException{
			assertEquals(ns,"aa");
		}
		public Object getTest(){
			return test;
		}
	}

}
