package fr.fluxmedia.transmorpher.stdlib;

import junit.framework.TestCase;
// JUnitDoclet begin import
import fr.fluxmedia.transmorpher.stdlib.broadcast;

import fr.fluxmedia.transmorpher.Utils.Parameters;
import org.xml.sax.ContentHandler;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.LocatorImpl;

import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the the authors.
*/


public class BroadcastTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  fr.fluxmedia.transmorpher.stdlib.broadcast broadcast = null;
	String pIn[]={"in"};
	String pOut[]={"out1","out2"};
	Parameters param=null;
	// JUnitDoclet end class
  
  public BroadcastTest(String name) {
    // JUnitDoclet begin method broadcastTest()
    super(name);
    // JUnitDoclet end method broadcastTest()
  }
  
  public void setUp() throws Exception {
    // JUnitDoclet begin method setUp()
    super.setUp();
		param=new Parameters();	
    
		broadcast = new fr.fluxmedia.transmorpher.stdlib.broadcast(pIn,pOut,param);
		
		assertEquals(broadcast.getNameIn(0),"in");
		assertEquals(broadcast.getNameOut(0),"out1");
		assertEquals(broadcast.getNameOut(1),"out2");

		broadcast.setContentHandler(0,new UnitTestHandler());
		broadcast.setContentHandler(1,new UnitTestHandler());
		
		assertTrue(broadcast.contentHandlers[0]!=null);
		assertTrue(broadcast.contentHandlers[1]!=null);
    // JUnitDoclet end method setUp()
  }
  
  public void tearDown() throws Exception {
    // JUnitDoclet begin method tearDown()
    broadcast = null;
		pIn=null;
		pOut=null;
		param=null;
    super.tearDown();
    // JUnitDoclet end method tearDown()
  }
  
  public void testStartElement() throws Exception {
    // JUnitDoclet begin method testStartElement()
		broadcast.startElement("","","test",null);
		assertEquals(((UnitTestHandler)broadcast.contentHandlers[0]).getTest(),((UnitTestHandler)broadcast.contentHandlers[1]).getTest());
    // JUnitDoclet end method testStartElement()
  }
  
  public void testEndElement() throws Exception {
    // JUnitDoclet begin method testEndElement()
		broadcast.endElement("","","test");
    // JUnitDoclet end method testEndElement()
  }
  
  public void testSetDocumentLocator() throws Exception {
    // JUnitDoclet begin method testSetDocumentLocator()
		broadcast.setDocumentLocator(new LocatorImpl());
		assertEquals(((UnitTestHandler)broadcast.contentHandlers[0]).getTest(),((UnitTestHandler)broadcast.contentHandlers[1]).getTest());
		
    // JUnitDoclet end method testSetDocumentLocator()
  }
  
  public void testStartDocument() throws Exception {
    // JUnitDoclet begin method testStartDocument()
		broadcast.startDocument();
		broadcast.endDocument();
    // JUnitDoclet end method testStartDocument()
  }
  
  public void testEndDocument() throws Exception {
    // JUnitDoclet begin method testEndDocument()
		broadcast.startDocument();
		broadcast.endDocument();
    // JUnitDoclet end method testEndDocument()
  }
  
  public void testSkippedEntity() throws Exception {
    // JUnitDoclet begin method testSkippedEntity()
    // JUnitDoclet end method testSkippedEntity()
  }
  
  public void testProcessingInstruction() throws Exception {
    // JUnitDoclet begin method testProcessingInstruction()
		broadcast.processingInstruction("target","data");
		
		assertEquals(((UnitTestHandler)broadcast.contentHandlers[0]).getTest(),((UnitTestHandler)broadcast.contentHandlers[1]).getTest());
		
    // JUnitDoclet end method testProcessingInstruction()
  }
  
  public void testIgnorableWhitespace() throws Exception {
    // JUnitDoclet begin method testIgnorableWhitespace()
		
    // JUnitDoclet end method testIgnorableWhitespace()
  }
  
  public void testCharacters() throws Exception {
    // JUnitDoclet begin method testCharacters()
		char[] ch={'t','e','s','t'};
		broadcast.characters(ch,0,4);
		assertEquals(((UnitTestHandler)broadcast.contentHandlers[0]).getTest(),((UnitTestHandler)broadcast.contentHandlers[1]).getTest());
    
		// JUnitDoclet end method testCharacters()
  }
  
  public void testStartPrefixMapping() throws Exception {
    // JUnitDoclet begin method testStartPrefixMapping()
    // JUnitDoclet end method testStartPrefixMapping()
  }
  
  public void testEndPrefixMapping() throws Exception {
    // JUnitDoclet begin method testEndPrefixMapping()
    // JUnitDoclet end method testEndPrefixMapping()
  }
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testVault()
    // JUnitDoclet end method testVault()
  }
	
  class UnitTestHandler extends DefaultHandler{
				
		boolean isDocument=false;
		Object test="";
		
		public void startDocument() throws SAXException {
			isDocument=true;
		}
		
		public void endDocument() throws SAXException {
			assertTrue(isDocument);
			isDocument=false;
		}
		
		public void startElement(String ns, String localName, String name, Attributes atts) throws SAXException {
			assertEquals(ns,"");
			assertEquals(localName,"");
			assertNull(atts);
			assertEquals(name,"test");
			test=name;
		}
		
		public final void setDocumentLocator(Locator locator) {
			assertTrue(locator!=null);
			test=locator;
    }
		
		 public final void processingInstruction(java.lang.String target, java.lang.String data) throws SAXException {
			 assertEquals(target,"target");
			 assertEquals(data,"data");
			 
			 test=target;
    }
		public void endElement(String ns, String localName, String name) throws SAXException {
			assertEquals(ns,"");
			assertEquals(localName,"");
			assertEquals(name,"test");
		}
		
		public final void characters(char[] ch, int start, int length) throws SAXException{
			assertEquals(ch[start],'t');
			assertEquals(length,4);
			test=ch;
		}
		
		public Object getTest(){
			return test;
		}
	}
}
