package fr.fluxmedia.transmorpher.stdlib;

import junit.framework.TestCase;
// JUnitDoclet begin import
import fr.fluxmedia.transmorpher.stdlib.concat;

import fr.fluxmedia.transmorpher.Utils.Parameters;
import org.xml.sax.ContentHandler;
import org.xml.sax.helpers.DefaultHandler;

import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the the authors.
*/


public class ConcatTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  fr.fluxmedia.transmorpher.stdlib.concat concat = null;
	
	String pIn[]={"in1","in2"};
	String pOut[]={"out"};
	Parameters param=null;
  // JUnitDoclet end class
  
  public ConcatTest(String name) {
    // JUnitDoclet begin method concatTest()
    super(name);
    // JUnitDoclet end method concatTest()
  }
  
  public void setUp() throws Exception {
    // JUnitDoclet begin method setUp()
    super.setUp();
		param=new Parameters();
    concat = new fr.fluxmedia.transmorpher.stdlib.concat(pIn,pOut,param);
		
		assertEquals(concat.getNameIn(0),"in1");
		assertEquals(concat.getNameIn(1),"in2");
		assertEquals(concat.getNameOut(0),"out");
		
		
    // JUnitDoclet end method setUp()
  }
  
  public void tearDown() throws Exception {
    // JUnitDoclet begin method tearDown()
    concat = null;
		param=null;
		pIn=null;
		pOut=null;
    super.tearDown();
    // JUnitDoclet end method tearDown()
  }
  
  public void testIsLastHandler() throws Exception {
    // JUnitDoclet begin method testIsLastHandler()
		concat.iCurrentHandler = concat.iNbIn-1;
		
		assertTrue(concat.isLastHandler());
    // JUnitDoclet end method testIsLastHandler()
  }
  
  public void testIsFirstHandler() throws Exception {
    // JUnitDoclet begin method testIsFirstHandler()
		concat.iCurrentHandler=0;
		
		assertTrue(concat.isFirstHandler());
    // JUnitDoclet end method testIsFirstHandler()
  }
  
   public void testSetGetContentHandler() throws Exception {
		UnitTestHandler testHandler =  new UnitTestHandler();
    assertNull(concat.getContentHandler());
		concat.setContentHandler(testHandler);
		
		assertTrue(concat.getContentHandler()==testHandler);
  }
  
	public void testGetManagingHandler() throws Exception {
		assertTrue(concat.getManagingHandler() instanceof concatHandler);
		assertEquals(((concatHandler)concat.getManagingHandler()).iOwner,concat);	
	}
	
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testVault()
    // JUnitDoclet end method testVault()
  }


	 class UnitTestHandler extends DefaultHandler{
				
		boolean isDocument=false;
		Object test="";
		
		public void startDocument() throws SAXException {
			isDocument=true;
		}
		
		public void endDocument() throws SAXException {
			assertTrue(isDocument);
			isDocument=false;
		}
		
		public void startElement(String ns, String localName, String name, Attributes atts) throws SAXException {
			assertEquals(ns,"");
			assertEquals(localName,"");
			assertNull(atts);
			assertEquals(name,"test");
			test=name;
		}
		
		public final void setDocumentLocator(Locator locator) {
			assertTrue(locator!=null);
			test=locator;
    }
		
		 public final void processingInstruction(java.lang.String target, java.lang.String data) throws SAXException {
			 assertEquals(target,"target");
			 assertEquals(data,"data");
			 
			 test=target;
    }
		public void endElement(String ns, String localName, String name) throws SAXException {
			assertEquals(ns,"");
			assertEquals(localName,"");
			assertEquals(name,"test");
		}
		
		public final void characters(char[] ch, int start, int length) throws SAXException{
			assertEquals(ch[start],'t');
			assertEquals(length,4);
			test=ch;
		}
		
		public Object getTest(){
			return test;
		}
	 }
}
