package fr.fluxmedia.transmorpher.stdlib;

import junit.framework.TestCase;
// JUnitDoclet begin import
import fr.fluxmedia.transmorpher.stdlib.TestingDispatcher;

import fr.fluxmedia.transmorpher.Utils.Parameters;
import org.xml.sax.ContentHandler;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.LocatorImpl;

import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the the authors.
*/


public class TestingDispatcherTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  fr.fluxmedia.transmorpher.stdlib.TestingDispatcher testingdispatcher = null;
  String pIn[]={"in"};
	String pOut[]={"out1","out2"};
	Parameters param=null;
	// JUnitDoclet end class
  
  public TestingDispatcherTest(String name) {
    // JUnitDoclet begin method TestingDispatcherTest()
    super(name);
    // JUnitDoclet end method TestingDispatcherTest()
  }
  
  public void setUp() throws Exception {
    // JUnitDoclet begin method setUp()
    super.setUp();
		param=new Parameters();	
		
		param.setParameter("test","a");
		param.setParameter("value","a");
    testingdispatcher = new fr.fluxmedia.transmorpher.stdlib.TestingDispatcher(pIn,pOut,param);
    
		assertTrue(testingdispatcher.getNameIn(0).equals("in"));
		assertTrue(testingdispatcher.getNameOut(0).equals("out1"));
		assertTrue(testingdispatcher.getNameOut(1).equals("out2"));
		
		UnitTestHandler uh1=new UnitTestHandler();
		UnitTestHandler uh2=new UnitTestHandler();
		
		uh1.setName("then");
		uh2.setName("else");
		
		testingdispatcher.setContentHandler(0,uh1);
		testingdispatcher.setContentHandler(1,uh2);
		
		assertTrue(testingdispatcher.contentHandlers[0]!=null);
		assertTrue(testingdispatcher.contentHandlers[1]!=null);
    
		// JUnitDoclet end method setUp()
  }
  
  public void tearDown() throws Exception {
    // JUnitDoclet begin method tearDown()
    testingdispatcher = null;
		pIn=null;
		pOut=null;
		param=null;
    super.tearDown();
    // JUnitDoclet end method tearDown()
  }
  
  public void testStartElement() throws Exception {
    // JUnitDoclet begin method testStartElement()
		testingdispatcher.then = true;
		
		testingdispatcher.startElement("","","test",null);
		assertTrue(((UnitTestHandler)testingdispatcher.contentHandlers[0]).getTest()!=((UnitTestHandler)testingdispatcher.contentHandlers[1]).getTest());
    assertEquals(((UnitTestHandler)testingdispatcher.contentHandlers[0]).getTest(),"test");

		testingdispatcher.then = false;
		
		testingdispatcher.startElement("","","test",null);
		assertEquals(((UnitTestHandler)testingdispatcher.contentHandlers[1]).getTest(),"test");    
    // JUnitDoclet end method testStartElement()
  }
  
  public void testEndElement() throws Exception {
    // JUnitDoclet begin method testEndElement()
		testingdispatcher.then = true;

		testingdispatcher.startElement("","","test",null);
		assertTrue(((UnitTestHandler)testingdispatcher.contentHandlers[0]).getTest()!=((UnitTestHandler)testingdispatcher.contentHandlers[1]).getTest());
    assertEquals(((UnitTestHandler)testingdispatcher.contentHandlers[0]).getTest(),"test");

    // JUnitDoclet end method testEndElement()
  }
  
  public void testSetDocumentLocator() throws Exception {
    // JUnitDoclet begin method testSetDocumentLocator()
		testingdispatcher.then = true;

		Locator loc=new LocatorImpl();
		testingdispatcher.setDocumentLocator(loc);
		assertEquals(((UnitTestHandler)testingdispatcher.contentHandlers[0]).getTest(),loc);
		
    // JUnitDoclet end method testSetDocumentLocator()
  }
  
  public void testStartDocument() throws Exception {
    // JUnitDoclet begin method testStartDocument()
		testingdispatcher.then = true;

		testingdispatcher.startDocument();
		testingdispatcher.endDocument();
    // JUnitDoclet end method testStartDocument()
  }
  
  public void testEndDocument() throws Exception {
    // JUnitDoclet begin method testEndDocument()
		testingdispatcher.then = true;

		testingdispatcher.startDocument();
		testingdispatcher.endDocument();
    // JUnitDoclet end method testEndDocument()
  }
  
  public void testSkippedEntity() throws Exception {
    // JUnitDoclet begin method testSkippedEntity()
    // JUnitDoclet end method testSkippedEntity()
  }
  
  public void testProcessingInstruction() throws Exception {
    // JUnitDoclet begin method testProcessingInstruction()
		testingdispatcher.then = true;

		testingdispatcher.processingInstruction("target","data");
		assertEquals(((UnitTestHandler)testingdispatcher.contentHandlers[0]).getTest(),"target");
		
    // JUnitDoclet end method testProcessingInstruction()
  }
  
  public void testIgnorableWhitespace() throws Exception {
    // JUnitDoclet begin method testIgnorableWhitespace()
    // JUnitDoclet end method testIgnorableWhitespace()
  }
  
  public void testCharacters() throws Exception {
    // JUnitDoclet begin method testCharacters()
		testingdispatcher.then = true;

		char[] ch={'t','e','s','t'};
		testingdispatcher.characters(ch,0,4);
		assertEquals(((UnitTestHandler)testingdispatcher.contentHandlers[0]).getTest(),ch);

    // JUnitDoclet end method testCharacters()
  }
  
  public void testStartPrefixMapping() throws Exception {
    // JUnitDoclet begin method testStartPrefixMapping()
    // JUnitDoclet end method testStartPrefixMapping()
  }
  
  public void testEndPrefixMapping() throws Exception {
    // JUnitDoclet begin method testEndPrefixMapping()
    // JUnitDoclet end method testEndPrefixMapping()
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testVault()
    // JUnitDoclet end method testVault()
  }
  
	class UnitTestHandler extends DefaultHandler{
				
		boolean isDocument=false;
		Object test="";
		String handlerName="";
		
		public void startDocument() throws SAXException {
			isDocument=true;
		}
		
		public void endDocument() throws SAXException {
			if(handlerName.equals("then"))
				assertTrue(isDocument);
			isDocument=false;
		}
		
		public void startElement(String ns, String localName, String name, Attributes atts) throws SAXException {
			if(handlerName.equals("then")){
				assertEquals(ns,"");
				assertEquals(localName,"");
				assertNull(atts);
				assertEquals(name,"test");
				test=name;
			}
			test=name;
		}
		
		public final void setDocumentLocator(Locator locator) {
			if(handlerName.equals("then")){
				assertTrue(locator!=null);
			}
			test=locator;
    }
		
		 public final void processingInstruction(java.lang.String target, java.lang.String data) throws SAXException {
			 if(handlerName.equals("then")){
				 assertEquals(target,"target");
				 assertEquals(data,"data");
			}
			test=target;
    }
		public void endElement(String ns, String localName, String name) throws SAXException {
			if(handlerName.equals("then")){
				assertEquals(ns,"");
				assertEquals(localName,"");
				assertEquals(name,"test");
			}
		}
		
		public final void characters(char[] ch, int start, int length) throws SAXException{
			if(handlerName.equals("then")){
				assertEquals(ch[start],'t');
				assertEquals(length,4);
			}
			test=ch;
		}
		
		public Object getTest(){
			return test;
		}
		
		public void setName(String name){
			handlerName=name;
		}
	}
}

